/*
 * This file is generated by jOOQ.
 */
package jooq.model.tables;


import java.time.LocalDateTime;
import java.util.function.Function;

import jooq.model.Keys;
import jooq.model.Public;
import jooq.model.tables.records.CollisionRecord;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Function4;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Records;
import org.jooq.Row4;
import org.jooq.Schema;
import org.jooq.SelectField;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Collision extends TableImpl<CollisionRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.collision</code>
     */
    public static final Collision COLLISION = new Collision();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<CollisionRecord> getRecordType() {
        return CollisionRecord.class;
    }

    /**
     * The column <code>public.collision.plane_id</code>.
     */
    public final TableField<CollisionRecord, Integer> PLANE_ID = createField(DSL.name("plane_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.collision.other_plane_id</code>.
     */
    public final TableField<CollisionRecord, Integer> OTHER_PLANE_ID = createField(DSL.name("other_plane_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.collision.time</code>.
     */
    public final TableField<CollisionRecord, LocalDateTime> TIME = createField(DSL.name("time"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>public.collision.id</code>.
     */
    public final TableField<CollisionRecord, Long> ID = createField(DSL.name("id"), SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    private Collision(Name alias, Table<CollisionRecord> aliased) {
        this(alias, aliased, null);
    }

    private Collision(Name alias, Table<CollisionRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>public.collision</code> table reference
     */
    public Collision(String alias) {
        this(DSL.name(alias), COLLISION);
    }

    /**
     * Create an aliased <code>public.collision</code> table reference
     */
    public Collision(Name alias) {
        this(alias, COLLISION);
    }

    /**
     * Create a <code>public.collision</code> table reference
     */
    public Collision() {
        this(DSL.name("collision"), null);
    }

    public <O extends Record> Collision(Table<O> child, ForeignKey<O, CollisionRecord> key) {
        super(child, key, COLLISION);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public Identity<CollisionRecord, Long> getIdentity() {
        return (Identity<CollisionRecord, Long>) super.getIdentity();
    }

    @Override
    public UniqueKey<CollisionRecord> getPrimaryKey() {
        return Keys.COLLISION_PKEY;
    }

    @Override
    public Collision as(String alias) {
        return new Collision(DSL.name(alias), this);
    }

    @Override
    public Collision as(Name alias) {
        return new Collision(alias, this);
    }

    @Override
    public Collision as(Table<?> alias) {
        return new Collision(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public Collision rename(String name) {
        return new Collision(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Collision rename(Name name) {
        return new Collision(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public Collision rename(Table<?> name) {
        return new Collision(name.getQualifiedName(), null);
    }

    // -------------------------------------------------------------------------
    // Row4 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row4<Integer, Integer, LocalDateTime, Long> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Function)}.
     */
    public <U> SelectField<U> mapping(Function4<? super Integer, ? super Integer, ? super LocalDateTime, ? super Long, ? extends U> from) {
        return convertFrom(Records.mapping(from));
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Class,
     * Function)}.
     */
    public <U> SelectField<U> mapping(Class<U> toType, Function4<? super Integer, ? super Integer, ? super LocalDateTime, ? super Long, ? extends U> from) {
        return convertFrom(toType, Records.mapping(from));
    }
}
